﻿;-----------------------------------------------------------
;	A.I.VOICE in the Tray
;
;	「A.I.VOICE」と「PotatoVoiceHub」と「VoiceroidTalkPlusReceiverHub」を
;	非表示にする（≒タスクトレイに収納）するツール。
;
;	読み上げ用に常駐させる場合にタスクバーが埋まる問題対応。
;-----------------------------------------------------------

;Autoexec
	;環境設定
	#NoEnv				;環境変数無視
	#NoTrayIcon 			;トレイアイコン非表示起動
	#SingleInstance Force		;多重起動禁止
	SetWorkingDir,	%A_ScriptDir%	;作業ディレクトリ変更
	DetectHiddenWindows, On		;非表示ウィンドウを検出
	OnExit,	Sub_EndProcessing	;終了処理指定

	;ソフト情報設定
	Var_AppTilte	:= "A.I.VOICE in the Tray"		;タイトル
	Var_AppVer	:= "20230819"			;バージョン
	Var_AppIcon	:= "A.I.VOICE in the Tray.ico"	;メインアイコン(バックアップ用)

	;ウィンドウタイトル決定
	Var_AppWindowTitle	:= Var_AppTilte

	Gosub,	Sub_TreyIcon_Init	;タスクトレイアイコン周り初期化

	Goto, Sub_Gui_Init		;GUI初期化
Return


;-----------------------------------------------------------
;終了コマンド
Sub_End:
	ExitApp		;終了処理へ移行
Return


;終了処理
Sub_EndProcessing:
	Gosub	, Sub_ShowWindowAll	;ウィンドウを表示状態に復帰
	ExitApp				;本終了
Return


;-----------------------------------------------------------
;タスクトレイアイコン周り初期化
Sub_TreyIcon_Init:
	;トレイアイコン回り設定
	Menu, Tray, Tip, %Var_AppWindowTitle%		;タイトル設定


	;-----------------------------------------------------------
	;アイコン画像を「A.I.VOICE Editor」にする
	;「AIVoiceEditor.exe」のパスはiniファイルで変更できるようにしておく。
	IniRead	, Var_AppIcon_Ini
		, A.I.VOICE in the Tray.ini
		, Config
		, Icon

	;存在チェック
	If( FileExist( Var_AppIcon_Ini ) )
		Var_AppIcon := 	Var_AppIcon_Ini

	;実際の変更処理
	If( FileExist( Var_AppIcon ) )
		Menu, Tray, Icon, %Var_AppIcon%	;トレイアイコン指定


	;-----------------------------------------------------------
	;メニュー項目
	Menu, Tray, NoStandard			;標準項目抹消

	Menu, Tray, Add , タスクトレイに格納, Sub_HideWindowAll
	Menu, Tray, Add , ウィンドウ再表示, Sub_ShowWindowAll
	Menu, Tray, Add , ウィンドウハンドル再取得, Sub_FindWindowAll

	Menu, Tray, Add
	Menu, Tray, Add , ウィンドウ認識状態, Sub_Gui_Show
	Menu, Tray, Add , ツールを終了, Sub_End

	Menu, Tray, Default, タスクトレイに格納	;デフォルト指定

	Menu, Tray, Icon			;トレイアイコン表示
Return


;-----------------------------------------------------------
;GUI初期化
Sub_Gui_Init:
	;配置パラメータ
	GUI_CONTROL_PITCH_X		:= 5
	GUI_CONTROL_PITCH_Y		:= 2

	GUI_CONTROL_WIDTH_LABEL		:= 180
	GUI_CONTROL_WIDTH_DATA		:= 100
	GUI_CONTROL_WIDTH_BUTTON	:= 50
	GUI_CONTROL_HIGHT		:= 20

	Gui, Add, Text	, xm ym w%GUI_CONTROL_WIDTH_LABEL% h%GUI_CONTROL_HIGHT%
			, アプリ

	Gui, Add, Text	, x+%GUI_CONTROL_PITCH_X% yp w%GUI_CONTROL_WIDTH_DATA% h%GUI_CONTROL_HIGHT%
			, hWnd


	;A.I.VOICE Editor
	Gui, Add, Text	, xm y+%GUI_CONTROL_PITCH_Y% w%GUI_CONTROL_WIDTH_LABEL% h%GUI_CONTROL_HIGHT%
			, A.I.VOICE

	Gui, Add, Edit	, x+%GUI_CONTROL_PITCH_X% yp w%GUI_CONTROL_WIDTH_DATA% h%GUI_CONTROL_HIGHT% ReadOnly vCtrl_Edit_AIVOICE_hWnd
			, 0

	Gui, Add, Button, x+%GUI_CONTROL_PITCH_X% yp w%GUI_CONTROL_WIDTH_BUTTON% h%GUI_CONTROL_HIGHT% ReadOnly vCtrl_Button_Find_AIVOICE gSub_FindWindow
			, Find

	Gui, Add, Button, x+%GUI_CONTROL_PITCH_X% yp w%GUI_CONTROL_WIDTH_BUTTON% h%GUI_CONTROL_HIGHT% ReadOnly vCtrl_Button_Hide_AIVOICE gSub_HideWindow
			, Hide

	Gui, Add, Button, x+%GUI_CONTROL_PITCH_X% yp w%GUI_CONTROL_WIDTH_BUTTON% h%GUI_CONTROL_HIGHT% ReadOnly vCtrl_Button_Show_AIVOICE gSub_ShowWindow
			, Show


	;PotatoVoiceHub
	Gui, Add, Text	, xm y+%GUI_CONTROL_PITCH_Y% w%GUI_CONTROL_WIDTH_LABEL% h%GUI_CONTROL_HIGHT%
			, PotatoVoiceHub

	Gui, Add, Edit	, x+%GUI_CONTROL_PITCH_X% yp w%GUI_CONTROL_WIDTH_DATA% h%GUI_CONTROL_HIGHT% ReadOnly vCtrl_Edit_PotatoVoiceHub_hWnd
			, 0

	Gui, Add, Button, x+%GUI_CONTROL_PITCH_X% yp w%GUI_CONTROL_WIDTH_BUTTON% h%GUI_CONTROL_HIGHT% ReadOnly vCtrl_Button_Find_PotatoVoiceHub gSub_FindWindow
			, Find

	Gui, Add, Button, x+%GUI_CONTROL_PITCH_X% yp w%GUI_CONTROL_WIDTH_BUTTON% h%GUI_CONTROL_HIGHT% ReadOnly vCtrl_Button_Hide_PotatoVoiceHub gSub_HideWindow
			, Hide

	Gui, Add, Button, x+%GUI_CONTROL_PITCH_X% yp w%GUI_CONTROL_WIDTH_BUTTON% h%GUI_CONTROL_HIGHT% ReadOnly vCtrl_Button_Show_PotatoVoiceHub gSub_ShowWindow
			, Show


	;Voiceroid Talk Plus Receiver Hub
	Gui, Add, Text	, xm y+%GUI_CONTROL_PITCH_Y% w%GUI_CONTROL_WIDTH_LABEL% h%GUI_CONTROL_HIGHT%
			, Voiceroid Talk Plus Receiver Hub

	Gui, Add, Edit	, x+%GUI_CONTROL_PITCH_X% yp w%GUI_CONTROL_WIDTH_DATA% h%GUI_CONTROL_HIGHT% ReadOnly vCtrl_Edit_VTPRH_hWnd
			, 0

	Gui, Add, Button, x+%GUI_CONTROL_PITCH_X% yp w%GUI_CONTROL_WIDTH_BUTTON% h%GUI_CONTROL_HIGHT% ReadOnly vCtrl_Button_Find_VTPRH gSub_FindWindow
			, Find

	Gui, Add, Button, x+%GUI_CONTROL_PITCH_X% yp w%GUI_CONTROL_WIDTH_BUTTON% h%GUI_CONTROL_HIGHT% ReadOnly vCtrl_Button_Hide_VTPRH gSub_HideWindow
			, Hide

	Gui, Add, Button, x+%GUI_CONTROL_PITCH_X% yp w%GUI_CONTROL_WIDTH_BUTTON% h%GUI_CONTROL_HIGHT% ReadOnly vCtrl_Button_Show_VTPRH gSub_ShowWindow
			, Show


	;ウィンドウ仮表示
	Gui, Show, Hide, ウィンドウ認識状態

	;ウィンドウハンドル取得
	Gosub, Sub_FindWindowAll
Return


;-----------------------------------------------------------
;GUI表示
Sub_Gui_Show:
	Gui, Show
Return



;-----------------------------------------------------------
; 個別操作コマンド
;-----------------------------------------------------------
;ウィンドウ検索
Sub_FindWindow:
	;初期化
	Var_FindWindow_Result := 0

	;押されたボタン判別
	StringReplace, Var_FindWindow_TargetName, A_GuiControl, Ctrl_Button_Find_

	;A.I.VOICE
	If ( Var_FindWindow_TargetName == "AIVOICE" )
		Var_FindWindow_Result := WinExist("A.I.VOICE Editor")

	;PotatoVoiceHub
	If ( Var_FindWindow_TargetName == "PotatoVoiceHub" )
		Var_FindWindow_Result := WinExist("PotatoVoiceHub")

	;Voiceroid Talk Plus Receiver Hub
	If ( Var_FindWindow_TargetName == "VTPRH" )
	{
		Process, Exist, VoiceroidTalkPlusReceiverHub.exe
		Var_FindWindow_Result := WinExist( "ahk_pid " . ErrorLevel )
	}

	;対象アプリのhWndを書き込むコントロール名
	Var_FindWindow_hWnd_CtrlName 	:= "Ctrl_Edit_"
					. Var_FindWindow_TargetName
					. "_hWnd"
	;書き込む
	GuiControl	, Text
			, %Var_FindWindow_hWnd_CtrlName%
			, %Var_FindWindow_Result%
Return


;ウィンドウを隠す
Sub_HideWindow:
	;初期化
	Var_HideWindow_hWnd_CtrlName := ""

	;押されたボタン判別
	StringReplace, Var_HideWindow_TargetName, A_GuiControl, Ctrl_Button_Hide_

	;対象アプリのhWndが入ってるコントロール名
	Var_HideWindow_hWnd_CtrlName 	:= "Ctrl_Edit_"
					. Var_HideWindow_TargetName
					. "_hWnd"

	;hWnd取得
	GuiControlGet	, Var_HideWindow_hWnd
			,
			, %Var_HideWindow_hWnd_CtrlName%

	;ウィンドウを隠す
	If ( Var_HideWindow_hWnd )
	{
		WinHide	, ahk_id %Var_HideWindow_hWnd%
	}
Return


;ウィンドウ再表示
Sub_ShowWindow:
	;初期化
	Var_ShowWindow_hWnd_CtrlName := ""

	;押されたボタン判別
	StringReplace, Var_ShowWindow_TargetName, A_GuiControl, Ctrl_Button_Show_

	;対象アプリのhWndが入ってるコントロール名
	Var_ShowWindow_hWnd_CtrlName 	:= "Ctrl_Edit_"
					. Var_ShowWindow_TargetName
					. "_hWnd"

	;hWnd取得
	GuiControlGet	, Var_ShowWindow_hWnd
			,
			, %Var_ShowWindow_hWnd_CtrlName%

	;ウィンドウを表示
	If ( Var_ShowWindow_hWnd )
	{
		WinShow	, ahk_id %Var_ShowWindow_hWnd%
	}
Return



;-----------------------------------------------------------
; 一括操作コマンド
; 全ウィンドウ検索は定期実行される。
;-----------------------------------------------------------
;全ウィンドウ検索
Sub_FindWindowAll:
	;初期化
	Var_FindWindow_Result		:= 0
	Var_FindWindowAll_NotFound	:= 0

	;whnd取得
	Loop	, 3
	{
		;A.I.VOICE
		If ( A_Index == 1 )
		{
			Var_FindWindow_TargetName := "AIVOICE"
			Var_FindWindow_Result := WinExist("A.I.VOICE Editor")
		}

		;PotatoVoiceHub
		If ( A_Index == 2 )
		{
			Var_FindWindow_TargetName := "PotatoVoiceHub"
			Var_FindWindow_Result := WinExist("PotatoVoiceHub")
		}

		;Voiceroid Talk Plus Receiver Hub
		If ( A_Index == 3 )
		{
			Var_FindWindow_TargetName := "VTPRH"
			Process, Exist, VoiceroidTalkPlusReceiverHub.exe
			Var_FindWindow_Result := WinExist( "ahk_pid " . ErrorLevel )
		}


		;対象アプリのhWndを書き込むコントロール名
		Var_FindWindow_hWnd_CtrlName 	:= "Ctrl_Edit_"
						. Var_FindWindow_TargetName
						. "_hWnd"

		;書き込む
		GuiControl	, Text
				, %Var_FindWindow_hWnd_CtrlName%
				, %Var_FindWindow_Result%

		;ウィンドウが見つからない
		If ( !Var_FindWindow_Result )
		{
			Var_FindWindowAll_NotFound := 1
		}
	}

	;次回チェックをセット
	If ( Var_FindWindowAll_NotFound )
		SetTimer, Sub_FindWindowAll, 2000	;どれか一つでも見つからない場合2秒後に再チェック
	else
		SetTimer, Sub_FindWindowAll, 15000	;フェイルセーフは15秒
Return


;全ウィンドウ隠す
Sub_HideWindowAll:
	;初期化
	Var_HideWindow_hWnd_CtrlName := ""

	;ループ
	Loop	, 3
	{
		;A.I.VOICE
		If ( A_Index == 1 )
			Var_HideWindow_TargetName := "AIVOICE"

		;PotatoVoiceHub
		If ( A_Index == 2 )
			Var_HideWindow_TargetName := "PotatoVoiceHub"

		;Voiceroid Talk Plus Receiver Hub
		If ( A_Index == 3 )
			Var_HideWindow_TargetName := "VTPRH"


		;対象アプリのhWndが入ってるコントロール名
		Var_HideWindow_hWnd_CtrlName 	:= "Ctrl_Edit_"
						. Var_HideWindow_TargetName
						. "_hWnd"

		;hWnd取得
		GuiControlGet	, Var_HideWindow_hWnd
				,
				, %Var_HideWindow_hWnd_CtrlName%

		;ウィンドウを隠す
		If ( Var_HideWindow_hWnd )
		{
			WinHide	, ahk_id %Var_HideWindow_hWnd%
		}
	}

	;デフォルト変更
	Menu, Tray, Default, ウィンドウ再表示
Return


;全ウィンドウ表示
Sub_ShowWindowAll:
	;初期化
	Var_ShowWindow_hWnd_CtrlName := ""

	;ループ
	Loop	, 3
	{
		;PotatoVoiceHub
		If ( A_Index == 1 )
			Var_ShowWindow_TargetName := "PotatoVoiceHub"

		;Voiceroid Talk Plus Receiver Hub
		If ( A_Index == 2 )
			Var_ShowWindow_TargetName := "VTPRH"

		;A.I.VOICE
		If ( A_Index == 3 )
			Var_ShowWindow_TargetName := "AIVOICE"


		;対象アプリのhWndが入ってるコントロール名
		Var_ShowWindow_hWnd_CtrlName 	:= "Ctrl_Edit_"
						. Var_ShowWindow_TargetName
						. "_hWnd"

		;hWnd取得
		GuiControlGet	, Var_ShowWindow_hWnd
				,
				, %Var_ShowWindow_hWnd_CtrlName%

		;ウィンドウを表示
		If ( Var_ShowWindow_hWnd )
		{
			WinShow	, ahk_id %Var_ShowWindow_hWnd%

			;A.I.VOICEを前面に
			If ( A_Index == 3 )
				WinActivate , ahk_id %Var_ShowWindow_hWnd%
		}
	}

	;デフォルト変更
	Menu, Tray, Default, タスクトレイに格納
Return
